# $Revision: 1.25.2.7 $, $Date: 2011/04/29 06:55:30 $
#
# Warning: OPAL and Ekiga are very fragile to ptlib version changes
#	even if they compile with newer ptlib that recommended
#	things may not work properly. Do not upgrade without testing!
#
#	Recommended versions for Ekiga can be found at:
#		http://wiki.ekiga.org/index.php/Download_Ekiga_sources
#
#	As for 2011-04-28 ptlib-2.6.x is recommended for for stable ekiga (3.2)
#	but it seems to work with ptlib-2.8 too.
#
# Conditional build:
%bcond_without	http		# Disable http support
%bcond_without	ipv6		# Disable ipv6 support
%bcond_without	odbc		# Disable ODBC support
%bcond_without	plugins		# Disable plugins support
%bcond_without	resolver	# Disable resolver support
%bcond_without	openssl		# Disable openssl support
%bcond_without	video		# Disable video support
%bcond_with	v4l		# Enable v4l (not v4l2) support.
                                # won't build with recent linux-libc-headers 
#
Summary:	Portable Tools Library
Summary(pl.UTF-8):	Przenośna biblioteka narzędziowa
Name:		ptlib
Version:	2.8.4
Release:	2
Epoch:		1
URL:		http://www.opalvoip.org/
Source0:	http://downloads.sourceforge.net/opalvoip/%{name}-%{version}.tar.bz2
# Source0-md5:	b851295423a96a9e8df58a8e329bf284
Patch0:		%{name}-std_allocator.patch
License:	MPLv1.0
Group:		Libraries
%{?with_video:BuildRequires:	SDL-devel}
%if %{with plugins}
BuildRequires:	alsa-lib-devel
BuildRequires:	libv4l-devel
BuildRequires:	pulseaudio-devel
%endif
BuildRequires:	bison
BuildRequires:	expat-devel
BuildRequires:	flex
#BuildRequires:	libavc1394-devel
#BuildRequires:	libdc1394-devel < 2.0.0
BuildRequires:	libstdc++-devel
%{?with_openssl:BuildRequires:	openssl-devel}
BuildRequires:	pkgconfig
%{?with_odbc:BuildRequires:	unixODBC-devel}
Obsoletes:	ptlib-sound-esd
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PTLib (Portable Tools Library) is a moderately large class library
that has it's genesis many years ago as PWLib (portable Windows
Library), a method to product applications to run on both Microsoft
Windows and Unix systems. It has also been ported to other systems
such as Mac OSX, VxWorks and other embedded systems.

It is supplied mainly to support the OPAL project, but that shouldn't
stop you from using it in whatever project you have in mind if you so
desire.

%description -l pl.UTF-8
PTLib (przenośna biblioteka narzędziowa) jest względnie dużą
biblioteką, która wywodzi się z PWLib (przenośna biblioteka Windows)
służącej do tworzenia aplikacji działających zarówno w systemach
Microsoft Windows jak i Unix. Została także przeniesiona na inne
systemy takie jak Mac OSX, VxWorks i inne wbudowane.

Zestaw ten powstał by wspierać projekt OPAL, to nie powinno jednak być
przeszkodą by móc go wykorzystać do innych celów jeśli tylko ktoś ma
na to ochotę.

%package devel
Summary:	PTLib (Portable Tools Library) development files
Summary(pl.UTF-8):	PTLib pliki deweloperskie
Group:		Development/Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}


%description devel
Header files and libraries for developing applications that use ptlib.

%description devel -l pl.UTF-8
Pliki nagłówkowe i biblioteki dla aplikacji korzystających z ptlib.

%package static
Summary:	PTLib (Portable Tools Library) static libraries
Summary(pl.UTF-8):	Biblioteki statyczne PTLib
Group:		Development/Libraries
Requires:	%{name}-devel = %{epoch}:%{version}-%{release}


%description static
PTLib (Portable Tools Library) static libraries.

%description static -l pl.UTF-8
Biblioteki statyczne PTLib.

%package sound-alsa
Summary:	Alsa audio plugin
Summary(pl.UTF-8):	Alsa wtyczka audio
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Provides:	%{name}-sound

%description sound-alsa
Alsa audio plugin.

%description sound-alsa -l pl.UTF-8
Alsa wtyczka audio.

%package sound-pulse
Summary:	Pulse audio plugin
Summary(pl.UTF-8):	Pulse wtyczka audio
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Provides:	%{name}-sound

%description sound-pulse
Alsa audio plugin.

%description sound-pulse -l pl.UTF-8
Alsa wtyczka audio.

%package sound-oss
Summary:	OSS audio plugin
Summary(pl.UTF-8):	OSS wtyczka audio
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}
Provides:	%{name}-sound

%description sound-oss
OSS audio plugin.

%description sound-oss -l pl.UTF-8
OSS wtyczka audio.

%package video-v4l
Summary:	v4l video input plugin
Summary(pl.UTF-8):	v4l wejściowa wtyczka wideo
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description video-v4l
v4l video input plugin.

%description video-v4l -l pl.UTF-8
v4l wejściowa wtyczka wideo.

%package video-v4l2
Summary:	v4l2 video input plugin
Summary(pl.UTF-8):	v4l2 wejściowa wtyczka wideo
Group:		Libraries
Requires:	%{name} = %{epoch}:%{version}-%{release}

%description video-v4l2
v4l2 video input plugin.

%description video-v4l2 -l pl.UTF-8
v4l2 wejściowa wtyczka wideo.

%package video-avc 
Summary: AVC 1394 video input plugin 
Group: Libraries 
Requires: %{name} = %{epoch}:%{version}-%{release}

%description video-avc 
AVC 1394 video input plugin.

%prep
%setup -q
%patch0 -p1

%build
# note: --enable-opal influences most of the remaining enable/disable defaults
%configure \
		--prefix=%{_prefix} \
		--enable-opal \
%if %{with plugins}
		--enable-plugins \
		--enable-alsa \
		--enable-oss \
		--enable-v4l2 \
		--enable-v4l \
%else
		--disable-plugins \
		--disable-alsa \
		--disable-oss \
		--disable-v4l2 \
		--%{?with_v4l:en}%{!?with_v4l:dis}able-v4l \
%endif
		--disable-esd \
%if %{with http}
		--enable-http \
		--enable-httpforms \
		--enable-httpsvc \
%else
		--disable-http \
		--disable-httpforms \
		--disable-httpsvc \
%endif
		--%{?with_ipv6:en}%{!?with_ipv6:dis}able-ipv6 \
		--%{?with_odbc:en}%{!?with_odbc:dis}able-odbc \
		--%{?with_resolver:en}%{!?with_resolver:dis}able-resolver \
		--%{?with_openssl:en}%{!?with_openssl:dis}able-openssl \
		--%{?with_video:en}%{!?with_video:dis}able-video \
		--disable-avc \
		--disable-dc \
		--enable-debug


dir=$(pwd)
%{__make} %{?debug:debugshared}%{!?debug:optshared} \
	V=1 \
	PTLIBMAKEDIR="$dir/make" \
	PTLIBDIR="$dir" \
	CFLAGS="%{rpmcflags} %{!?debug:-DNDEBUG} -DUSE_GCC" \
	LDFLAGS="%{rpmcflags} %{rpmldflags} %{!?debug:-DNDEBUG}" \
	CXX="%{__cxx}"


%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir},%{_includedir}/%{name}}

dir=$(pwd)
%{__make} install \
	V=1 \
	DESTDIR=$RPM_BUILD_ROOT

cp version.h $RPM_BUILD_ROOT%{_includedir}/%{name}

sed -i -e 's#PTLIBDIR=.*#PTLIBDIR=%{_datadir}/ptlib#g' $RPM_BUILD_ROOT%{_datadir}/ptlib/make/plugins.mak

chmod a+x $RPM_BUILD_ROOT%{_libdir}/lib*.so.*
find $RPM_BUILD_ROOT%{_libdir}/ptlib-* -name '*.so' | xargs chmod a+x

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpt.so.*.*.*
%if %{with plugins}
%dir %{_libdir}/%{name}-%{version}
%dir %{_libdir}/%{name}-%{version}/devices
%dir %{_libdir}/%{name}-%{version}/devices/sound
%dir %{_libdir}/%{name}-%{version}/devices/videoinput
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libpt*.so
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/make
%attr(755,root,root) %{_bindir}/*
%attr(755,root,root) %{_datadir}/%{name}/make/%{name}-config
%{_includedir}/ptclib
%{_includedir}/ptlib
%{_includedir}/*.h
%{_datadir}/%{name}/make/*.mak
%{_pkgconfigdir}/%{name}.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/lib*.a

%if %{with plugins}
%files sound-alsa
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/sound/alsa_pwplugin.so

%files sound-pulse
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/sound/pulse_pwplugin.so

%files sound-oss
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/sound/oss_pwplugin.so

%if %{with v4l}
%files video-v4l
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/videoinput/v4l_pwplugin.so
%endif

%files video-v4l2
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/videoinput/v4l2_pwplugin.so

%if 0
%files video-avc
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}-%{version}/devices/videoinput/avc_pwplugin.so
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ptlib.spec,v $
Revision 1.25.2.7  2011/04/29 06:55:30  jajcus
- disable v4l plugin - it won't build with current linux-libc-headers and is probably obsolete anyway

Revision 1.25.2.6  2011/04/29 06:26:11  jajcus
- Release: 2

Revision 1.25.2.5  2011/04/28 15:49:21  jajcus
- another R: fix

Revision 1.25.2.4  2011/04/28 15:46:39  jajcus
- R: fixes

Revision 1.25.2.3  2011/04/28 13:39:42  jajcus
- Epoch: 1
- warning about version compatibility
- fixed the way video-avc codec is disabled (it seems it was commented out and
  then mangled by the adapter script)

Revision 1.25.2.2  2011/04/28 11:21:03  jajcus
- use std:allocator instead of some internal GCC API (which crashes ptlib apps
  with our GCC/libstdc++)

Revision 1.25.2.1  2011/04/28 11:13:03  jajcus
- better passing of %{rpmcflags} and %{rpmldflags}
- use verbose build so the flags used are visible
- do not include all static libraries from the build system
- set executable bit on shared libraries, so their debuginfo is extracted

Revision 1.25  2011/01/03 08:57:39  caleb
- Up to 2.8.3

Revision 1.24  2010/11/28 12:00:12  sls
- added Obsoletes: ptlib-sound-esd in main pkg

Revision 1.23  2010/11/12 17:58:47  sls
- added BR: pulseaudio-devel

Revision 1.22  2010/11/11 11:49:56  caleb
- Up to 2.8.2
- Added subpackage for pulse audio plugin

Revision 1.21  2010/10/02 14:10:05  wiget
- removed esd plugin

Revision 1.20  2010/07/26 22:21:51  zbyniu
- up to 2.6.7

Revision 1.19  2010/05/05 08:57:30  jajcus
- Release: 9 (needs rebuild with the new openssl)

Revision 1.18  2010/02/20 11:38:08  mmazur
- typo

Revision 1.17  2010/02/20 11:14:47  mmazur
- four more bconds

Revision 1.16  2010/02/18 17:19:14  mmazur
- removed obsolete/nonexistant ./configure flags
- added bconds: odbc plugins video

Revision 1.15  2010/01/22 21:14:29  arekm
- rel 8

Revision 1.14  2010/01/22 21:13:08  arekm
rel 7; revert provides pwlib

Revision 1.13  2010/01/09 20:43:57  arekm
- rel 6; pwlib symlink
Revision 1.12  2010/01/09 20:19:45  arekm
- rel 5; path fixes

Revision 1.11  2010/01/09 19:54:12  arekm
- rel 4; ptlib-config has to be executable

Revision 1.10  2010/01/09 19:37:05  arekm
rel 3; provides pwlib packages

Revision 1.9  2010/01/08 22:01:04  arekm
- rel 2; enable http stuff

Revision 1.8  2010/01/08 21:40:02  arekm
- up to 2.6.5

Revision 1.7  2009/09/13 22:05:17  wrobell
- ver. 2.6.4

Revision 1.6  2009/01/15 20:55:06  duddits
- up to 2.4.4
- pl

Revision 1.5  2008/11/18 02:26:35  sls
- more BR
- updated TODO
- added sound-esd subpackege

Revision 1.4  2008/11/18 01:29:39  sls
- more BR
- added TODO

Revision 1.3  2008/11/09 00:04:18  sls
- Obsolete: pwlib-foo-bar in ptlib-foo-bar
- rel. 2

Revision 1.2  2008/10/28 09:53:43  hawk
- add md5

Revision 1.1  2008/10/27 18:06:07  emes
- first release

